package com.muzhi.tianhe.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.muzhi.tianhe.service.ThTbService;
import com.muzhi.tianhe.util.PublicUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.lang.reflect.Array;
import java.util.*;

@Slf4j
@Service
public class ThTbServiceImpl implements ThTbService {

    @Autowired
    private TbApiService tbApiService;


    @Override
    public void task(String taskId) {
        JSONObject task=tbApiService.getTasksInfo(taskId).getJSONObject(0);
        String projectId=task.getString("projectId");
        // 先判断项目分组
        JSONArray array=tbApiService.getProjectTag(projectId);
        if(array==null||array.size()<1){
            log.info("不属于战略部分组的项目，不处理");
            return;
        }
        if(!Arrays.asList("65b77b8f7bbdd92f48e6920d","664d5b10e6451d2386a49b8b","664d5b15a1a96d9b5815d6fd").contains(array.getString(0))){
            log.info("不属于战略部分组的项目，不处理");
            return;
        }
//        String tfsId=task.getString("tfsId");// 状态ID
//        JSONObject tfs=tbApiService.getProjectStateId(projectId,"","",tfsId).getJSONObject(0);
        // 任务类型判断
        String sfcId=task.getString("sfcId");
        List<JSONObject> list=tbApiService.getTasksType(projectId).toJavaList(JSONObject.class);
        Optional optional = list.stream().filter(item -> sfcId.equals(item.get("id"))).findAny();
        JSONObject taskType=((JSONObject) optional.get());
        String name=taskType.getString("name");
        String tfid=taskType.getString("taskflowId");
        if(name.contains("变更流程")){
            log.info("变更流程");
//            taskChange(task,taskId);
        }else if(name.contains("任务取消")){
            log.info("任务取消");
//            taskCancel(task,taskId);
        }else if(name.contains("新增流程")){
            log.info("新增流程");
//            String newName;
//            if(name.contains("一级")){
//                newName="一级任务";
//            }else if(name.contains("二级")){
//                newName="二级任务";
//            }else if(name.contains("三级")){
//                newName="三级任务";
//            }else{
//                log.error("任务类型名称判断异常：{}",name);
//                return;
//            }
//            Optional optional2 = list.stream().filter(item -> newName.equals(item.get("name"))).findAny();
//            JSONObject newTaskType=((JSONObject) optional2.get());
//            taskAdd(task,taskId,newTaskType);
        }else if(name.equals("年度指标")){
            log.info("年度指标");
            updateTaskState(task,tfid);
        }else{
            log.info("任务 {} 任务类型：{} 非期望类型任务 不处理",task.getString("content"),name);
        }

    }

    public void updateTaskState(JSONObject task,String tfid){
        String projectId=task.getString("projectId");// 项目ID
        // 上级任务信息
        String parentTaskId=task.getString("parentTaskId");// 上级任务ID
        JSONObject parentTask=tbApiService.getTasksInfo(parentTaskId).getJSONObject(0);
        JSONObject parentTaskTfs=tbApiService.getProjectStateId(projectId,"","",parentTask.getString("tfsId")).getJSONObject(0);
        String parentTaskTfsName=parentTaskTfs.getString("name");
        String newTfsName;
        // 循环获取其他同级任务状态，判断是否有更高级别的任务状态
        // 同级红灯状态ID
        JSONObject redTfs=tbApiService.getProjectStateId(projectId,"红灯",tfid,"").getJSONObject(0);
        String redId=redTfs.getString("id");
        // 同级黄状态ID
        JSONObject yellowTfs=tbApiService.getProjectStateId(projectId,"黄灯",tfid,"").getJSONObject(0);
        String yellowId=yellowTfs.getString("id");
        // 指标任务状态
        String redZbId,yellowZbId;

        JSONObject zbtf=tbApiService.getProjectTfid(projectId,"年度指标工作流").getJSONObject(0);
        if(tfid.equals(zbtf.getString("id"))){
            redZbId=redId;
            yellowZbId=yellowId;
        }else{
            JSONObject redZbTfs=tbApiService.getProjectStateId(projectId,"红灯",zbtf.getString("id"),"").getJSONObject(0);
            redZbId=redZbTfs.getString("id");
            // 同级黄状态ID
            JSONObject yellowZbTfs=tbApiService.getProjectStateId(projectId,"黄灯",zbtf.getString("id"),"").getJSONObject(0);
            yellowZbId=yellowZbTfs.getString("id");
        }

        JSONArray array=tbApiService.getTasksByParent(parentTaskId);
        String color="绿灯";
        int redNum=0,yellowNum=0;
        for (int i = 0; i < array.size(); i++) {
            JSONObject taskT=array.getJSONObject(i);
            if(redId.equals(taskT.getString("tfsId"))||redZbId.equals(taskT.getString("tfsId"))){
                redNum++;
            }else if(yellowId.equals(taskT.getString("tfsId"))||yellowZbId.equals(taskT.getString("tfsId"))){
                yellowNum++;
            }
        }
        if(yellowNum>=1){
            color="黄灯";
        }
        if(redNum>=1){
            color="红灯";
        }
        if(!color.equals(parentTaskTfsName)){
            newTfsName=color;
        }else{
            return;
        }
        // 任务类型判断
        String parentSfcId=parentTask.getString("sfcId");
        List<JSONObject> list=tbApiService.getTasksType(projectId).toJavaList(JSONObject.class);
        Optional optional = list.stream().filter(item -> parentSfcId.equals(item.get("id"))).findAny();
        JSONObject parentTaskType=((JSONObject) optional.get());
        String parentTfid=parentTaskType.getString("taskflowId");

        update(projectId,parentTaskId,newTfsName,parentTfid);
        if(!PublicUtil.isNull(parentTask.getString("parentTaskId"))){
            updateTaskState(parentTask,parentTfid);
        }
    }

    public void taskChange(JSONObject task,String taskId){
        String projectId=task.getString("projectId");// 项目ID
        // 查询项目自定义字段
        List<JSONObject> list=tbApiService.getProjectCustomfield(projectId).toJavaList(JSONObject.class);
        Optional optional = list.stream().filter(item -> "变更内容".equals(item.get("name"))&&item.containsKey("originalId")).findAny();
        String keyId=((JSONObject) optional.get()).getString("id");
        Optional optional2 = list.stream().filter(item -> "变更后内容".equals(item.get("name"))).findAny();
        String valueId=((JSONObject) optional2.get()).getString("id");
        // 查询任务中的自定义字段值
        List<JSONObject> custs=task.getJSONArray("customfields").toJavaList(JSONObject.class);
        Optional optional3 = custs.stream().filter(item -> valueId.equals(item.get("cfId"))).findAny();
        String value=((JSONObject) optional3.get()).getJSONArray("value").getJSONObject(0).getString("title");
        Optional optional4 = custs.stream().filter(item -> keyId.equals(item.get("cfId"))).findAny();
        JSONObject idObj=((JSONObject) optional4.get()).getJSONArray("value").getJSONObject(0);
        // 查询关联任务
        JSONArray linkArray=tbApiService.getTaskLinks(taskId);
        if(linkArray==null||linkArray.size()<1){
            log.info("任务{}没有关联任务",taskId);
            return;
        }
        String linkedId=linkArray.getJSONObject(0).getString("linkedId");
        log.info("任务[{}]字段:{}[{}]数据修改为：{}",linkedId,idObj.getString("title"),idObj.getString("id"),value);
        if("664e9d5ae6451d2386a6d1bc".equals(idObj.getString("id"))){
            tbApiService.updateTaskContent(linkedId,value);
        }else if("664e9d5ae6451d2386a6d1bd".equals(idObj.getString("id"))){
            Optional optional5 = list.stream().filter(item -> "权重".equals(item.get("name"))).findAny();
            String qzId=((JSONObject) optional5.get()).getString("id");
            tbApiService.updateTaskCustomfield(linkedId,qzId,value);
        }else if("664e9d5ae6451d2386a6d1be".equals(idObj.getString("id"))){
            JSONArray array=tbApiService.userSearch(value);
            if(array==null||array.size()<1){
                log.error("未查到该人员 查询条件：{},返回结果：{}",value,array);
                return;
            }
            tbApiService.updateTaskExecutor(linkedId,array.getJSONObject(0).getString("userId"));
        }
    }


    public void taskCancel(JSONObject task,String taskId){
        // 查询关联任务
        JSONArray linkArray=tbApiService.getTaskLinks(taskId);
        if(linkArray==null||linkArray.size()<1){
            log.info("任务{}没有关联任务",taskId);
            return;
        }
        String linkedId=linkArray.getJSONObject(0).getString("linkedId");
        log.info("任务[{}]状态修改为[取消]",linkedId);
        JSONObject linkedTask=tbApiService.getTasksInfo(linkedId).getJSONObject(0);
        String projectId=linkedTask.getString("projectId");
        JSONObject tf=tbApiService.getProjectTfid(projectId,getType(linkedTask.getJSONArray("ancestorIds").size()+1)).getJSONObject(0);
        JSONObject tfsnext=tbApiService.getProjectStateId(projectId,"取消",tf.getString("id"),"").getJSONObject(0);
        tbApiService.updateTaskStatus(linkedId,tfsnext.getString("id"));
    }

    public void taskAdd(JSONObject task,String taskId,JSONObject newTaskType){
        String projectId=task.getString("projectId");
        // 查询项目自定义字段
        List<JSONObject> projectCoutList=tbApiService.getProjectCustomfield(projectId).toJavaList(JSONObject.class);
        Map<String,String> custIdMap=new HashMap();
        projectCoutList.forEach(item -> custIdMap.put(item.getString("name"),item.getString("id")));
        List<JSONObject> taskCoutlist=task.getJSONArray("customfields").toJavaList(JSONObject.class);
        Map<String,JSONArray> taskCustValueMap=new HashMap();
        taskCoutlist.forEach(item -> taskCustValueMap.put(item.getString("cfId"),item.getJSONArray("value")));

        JSONObject addTask=new JSONObject();
        addTask.put("projectId",projectId);// 必填
        addTask.put("content",taskCustValueMap.get(custIdMap.get("新任务目标")).getJSONObject(0).getString("title"));// 标题必填
        addTask.put("scenariofieldconfigId",newTaskType.getString("id"));// 任务类型id 业务必填
        if(!newTaskType.getString("name").contains("一级")){
            // 查询关联任务 用于确认父级任务
            JSONArray linkArray=tbApiService.getTaskLinks(taskId);
            if(linkArray==null||linkArray.size()<1){
                log.info("任务{}没有关联任务",taskId);
                return;
            }
            String linkedId=linkArray.getJSONObject(0).getString("linkedId");
            addTask.put("parentTaskId",linkedId);// 父任务ID
        }
        JSONArray array=new JSONArray();
        array.add(custField(custIdMap.get("权重"),taskCustValueMap.get(custIdMap.get("新任务权重")).getJSONObject(0).getString("title"),""));
        array.add(custField(custIdMap.get("联席责任人"),taskCustValueMap.get(custIdMap.get("联席责任人"))));
        array.add(custField(custIdMap.get("行政上级领导"),taskCustValueMap.get(custIdMap.get("行政上级领导"))));
        array.add(custField(custIdMap.get("责任人"),taskCustValueMap.get(custIdMap.get("新任务责任人"))));
        array.add(custField(custIdMap.get("上级任务责任人"),taskCustValueMap.get(custIdMap.get("上级任务责任人"))));
        addTask.put("customfields",array);
        JSONObject result=tbApiService.addTask(addTask);
        log.info("新增完成 result：{}",result);
    }

    private JSONObject custField(String cfId,String title,String id){
        JSONObject result=new JSONObject();
        result.put("cfId",cfId);
        result.put("value",Arrays.asList(new JSONObject().fluentPut("title",title).fluentPut("id",id)));
        return result;
    }

    private JSONObject custField(String cfId,JSONArray value){
        JSONObject result=new JSONObject();
        result.put("cfId",cfId);
        result.put("value",value);
        return result;
    }


    public String getType(int size){
        switch (size){
            case 1:
                return"一级任务工作流";
            case 2:
                return "二级任务工作流";
            case 3:
                return "三级任务工作流";
            case 4:
                return "年度指标工作流";
            default:return "";
        }
    }

    public void update(String projectId,String taskId,String tfsName,String tfid){
        log.info("任务[{}]状态修改为[{}]",taskId,tfsName);
        JSONObject tfsnext=tbApiService.getProjectStateId(projectId,tfsName,tfid,"").getJSONObject(0);
        tbApiService.updateTaskStatus(taskId,tfsnext.getString("id"));
    }
}
